apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: {{ include "transaction-service.fullname" . }}-apps-redirect-ingress
  namespace: {{ include "transaction-service.namespace" . }}
  labels:
    {{- include "transaction-service.labels" . | nindent 4 }}
  annotations:
    nginx.ingress.kubernetes.io/use-regex: "true"
    nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
    nginx.ingress.kubernetes.io/rewrite-target: /api/v1/transactions/$4$5
    nginx.ingress.kubernetes.io/configuration-snippet: |
      more_set_headers "X-Content-Type-Options: nosniff";
      more_set_headers "X-Frame-Options: SAMEORIGIN";
      more_set_headers "Content-Security-Policy: default-src 'self'";
      more_set_headers "Content-Security-Policy: script-src 'self' 'unsafe-inline'";
      more_set_headers "Referrer-Policy: no-referrer-when-downgrade";
      more_set_headers "Permissions-Policy: microphone=(), geolocation=(), camera=()";
spec:
  ingressClassName: {{ include "ingress.class.name" . }}
  rules:
    - host: {{ .Values.fqdn }}
      http:
        paths:
          # Redirect all /api/v1/apps/... requests except those ending with /messages
          - path: /({{ include "transaction-service.namespace" $ }}/)?(api/v1/)(controller/)?apps(?!.*/messages$)(.*)?
            pathType: ImplementationSpecific
            backend:
              service:
                name: {{ include "transaction-service.service.name" $ }}
                port:
                  number: {{ $.Values.ports.apiTarget }}
